<div *ngIf="currQuestion.isInTimeLimitWarningMode()" class="d-flex flex-column align-items-center justify-content-center mt-5">
  <h2>
    This question has a time limit of <b> {{ currQuestion.timeLeft }} seconds.</b>
    Press 'Show question' button below if you want to display it.
    {{errorUpdatingServerClock}}
  </h2>
  <h2 class="text-danger">
    {{errorUpdatingServerClock}}
  </h2>
  <button
    class="btn btn-primary mt-5"
    type="button"
    (click)="startTheClock()"
  >
    <h1>Show question - start the clock!</h1>
  </button>
</div>

<div
  *ngIf="currQuestion && currQuestion.isClockTicking()"
  class="row d-flex justify-content-center">
  <h3
    class="border rounded"
    id="aii-countdown"
    [class.aii-clock-error]="currQuestion.timeLeft < 10"
  >
    {{ currQuestion.timeLeft | clockCaption }}
  </h3>

</div>

<div
  *ngIf="currQuestion && currQuestion.isTimedOut()"
  class="row d-flex justify-content-center mt-5">
    <h1>Sorry, but the time to solve this question has expired!</h1>
</div>




<div class="row" *ngIf="currQuestion.isVisible()">
  <div
    [class.col-12]="layoutTutorial"
    [class.col-12]="!layoutHorizontal && !layoutTutorial"
    [class.col-6]="layoutHorizontal && !layoutTutorial"
  >
    <question-content-static [currQuestion]="currQuestion">
    </question-content-static>
  </div>
  <div
    [class.col-12]="layoutTutorial"
    [class.col-12]="!layoutHorizontal && !layoutTutorial"
    [class.col-6]="layoutHorizontal && !layoutTutorial"
  >
    <div *ngIf="currQuestion && currQuestion.modeDesc" class="text-left">
      <i>Check column mode: {{ currQuestion.modeDesc }}</i>
    </div>
    <question-free-text
      *ngIf="currQuestion && currQuestion.isFreeText()"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      [currQuestion]="currQuestion"
      [cmSkin]="_examService.getCodeMirrorSkin()"
      (answerUpdated)="onAnswerUpdated($event)"
      (answerSaved)="onAnswerSaved()"
      class="w-100"
    >
    </question-free-text>

    <question-code
      *ngIf="currQuestion && currQuestion.isRunnable()"
      #questionCode
      class="container-fluid"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      [currQuestion]="currQuestion"
      [currQuestionWait]="currQuestionWait"
      [cmSkin]="_examService.getCodeMirrorSkin()"
      (answerUpdated)="onAnswerUpdated($event)"
      (answerSaved)="onAnswerSaved()"
      (codeRun)="onAnswerEvaluated($event)"
    >
    </question-code>

    <abc
      *ngIf="currQuestion && currQuestion.isMultiChoice()"
      [currQuestion]="currQuestion"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      (answerUpdated)="onAnswerUpdated($event)"
      (answerSaved)="onAnswerSaved()"
    >
    </abc>

    <scale-item
      *ngIf="currQuestion && currQuestion.isScaleQuestion()"
      [currQuestion]="currQuestion"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      (scaleItemSelectedEmitter)="onScaleItemSelected($event)"
    ></scale-item>

    <app-question-true-false
      *ngIf="currQuestion && currQuestion.isTrueFalse()"
      [currQuestion]="currQuestion"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      (answerUpdated)="onAnswerUpdated($event)"
      (answerSaved)="onAnswerSaved()"
    >
    </app-question-true-false>

    <app-ordered-elements
      *ngIf="currQuestion && currQuestion.isOrderedElements()"
      [currQuestion]="currQuestion"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      (answerUpdated)="onAnswerUpdated($event)"
      (answerSaved)="onAnswerSaved()"
    >

    </app-ordered-elements>

    <app-connected-elements
      *ngIf="currQuestion && currQuestion.isConnectedElements()"
      [currQuestion]="currQuestion"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      (answerUpdated)="onAnswerUpdated($event)"
      (answerSaved)="onAnswerSaved()"
    >
    </app-connected-elements>

    <app-text-completion
      *ngIf="currQuestion && currQuestion.isTextCompletion()"
      [currQuestion]="currQuestion"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      (answerUpdated)="onAnswerUpdated($event)"
      (answerSaved)="onAnswerSaved()"
    >
    </app-text-completion>

    <diagram
      *ngIf="currQuestion && currQuestion.isDiagram()"
      [currQuestion]="currQuestion"
      [currAnswer]="_examService.getAnswer(currQuestion.ordinal)"
      [cmSkin]="_examService.getCodeMirrorSkin()"
      (answerUpdated)="onAnswerUpdated($event)"
      (answerSaved)="onAnswerSaved()"
      class="w-100"
    >
    </diagram>
  </div>
</div>
